;##################################################################
; DIALOG AS MAIN
;##################################################################

#include "ATLDemo.h"

#dynamiclinkfile atl.dll

COMObject  STRUCT
	; interface object
	lpVtbl			DD		0
	; object data
	nRefCount		DD		1
ENDS

// Custom messages
WBN_BEFORENAVIGATE equ WM_USER + DISPID_BEFORENAVIGATE
WBN_NAVIGATECOMPLETE equ WM_USER + DISPID_NAVIGATECOMPLETE
WBN_STATUSTEXTCHANGE equ WM_USER + DISPID_STATUSTEXTCHANGE
WBN_QUIT equ WM_USER + DISPID_QUIT
WBN_DOWNLOADCOMPLETE equ WM_USER + DISPID_DOWNLOADCOMPLETE
WBN_COMMANDSTATECHANGE equ WM_USER + DISPID_COMMANDSTATECHANGE
WBN_DOWNLOADBEGIN equ WM_USER + DISPID_DOWNLOADBEGIN
WBN_NEWWINDOW equ WM_USER + DISPID_NEWWINDOW
WBN_PROGRESSCHANGE equ WM_USER + DISPID_PROGRESSCHANGE
WBN_WINDOWMOVE equ WM_USER + DISPID_WINDOWMOVE
WBN_WINDOWRESIZE equ WM_USER + DISPID_WINDOWRESIZE
WBN_WINDOWACTIVATE equ WM_USER + DISPID_WINDOWACTIVATE
WBN_PROPERTYCHANGE equ WM_USER + DISPID_PROPERTYCHANGE
WBN_TITLECHANGE equ WM_USER + DISPID_TITLECHANGE
WBN_TITLEICONCHANGE equ WM_USER + DISPID_TITLEICONCHANGE

CMD_PREV equ WM_USER
CMD_NEXT equ WM_USER + 1
CMD_REFRESH equ WM_USER + 2
CMD_BROWSE equ WM_USER + 3
CMD_HOME equ WM_USER + 4
CMD_STOP equ WM_USER + 5

#define IDR_TBBITMAP 16
#define IDR_ICON 1

DATA SECTION
	// USER32 handles
	hInstance			DD 		?
	hDlg				DD		?
	hAtl				DD		?
	hToolBar			DD		?
	hImlLarge			DD		?
	hImlSmall			DD		?

	// Interface pointers
	pIUnknown			DD		?
	pIWebBrowser2		DD		?

	// Interface IIDs
	IID_IWebBrowser2	GUID	GUID_IID_IWebBrowser2
	IID_DWebBrowserEvents2 GUID GUID_IID_DWebBrowserEvents2
	IID_IUnknown GUID GUID_IID_IUnknown
	IID_IDispatch GUID GUID_IID_IDispatch

	url					DB		1024 DUP (?)

	// AtlAdvise cookie
	dwCookie			DD	0

	// Our DWebBrowserEvents2 interface
	objEventSync		COMObject	<offset vtblEventSync,1>
	vtblEventSync		DD DWebBrowserEvents2_QueryInterface
						DD DWebBrowserEvents2_AddRef
						DD DWebBrowserEvents2_Release
						DD DWebBrowserEvents2_GetTypeInfoCount
						DD DWebBrowserEvents2_GetTypeInfo
						DD DWebBrowserEvents2_GetIDsOfNames
						DD DWebBrowserEvents2_Invoke

	// Class name for the dialog
	ClassName			DB		"DialogClass",0

	ALIGN 16
	tbrbtns				TBBUTTON	<0,CMD_PREV,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0,0>
						TBBUTTON	<1,CMD_NEXT,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0,0>
						TBBUTTON	<2,CMD_STOP,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0,0>
						TBBUTTON	<3,CMD_REFRESH,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0,0>
						TBBUTTON	<4,CMD_HOME,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0,0>

	tbbend:
	nToolbarBtns		equ	(tbbend-tbrbtns) /SIZEOF TBBUTTON

CODE SECTION

Start:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke CoInitialize,NULL
	invoke InitCommonControls
	invoke WinMain,[hInstance],NULL,NULL,SW_SHOW
	invoke CoUninitialize
	invoke ExitProcess,0

WinMain FRAME hInst,hPrevInstance,lpCmdLine,nCmdShow
	LOCAL	wc				:WNDCLASSEX
	LOCAL	msg				:MSG
	LOCAL	hdc				:D
	LOCAL	rect			:RECT

	; Define our main window class and register it
	mov		D[wc.cbSize], SIZEOF WNDCLASSEX
	mov		D[wc.style], CS_HREDRAW + CS_VREDRAW
	mov		D[wc.lpfnWndProc], OFFSET DlgProc
	mov		D[wc.cbClsExtra], NULL
	mov		D[wc.cbWndExtra], DLGWINDOWEXTRA
	mov		eax, [hInstance]
	mov		D[wc.hInstance], eax
	mov		D[wc.hbrBackground], COLOR_BTNFACE + 1
	mov		D[wc.lpszMenuName], NULL
	mov		D[wc.lpszClassName], OFFSET ClassName
	invoke	LoadIcon, NULL, IDI_APPLICATION
	mov		D[wc.hIcon], eax
	mov		D[wc.hIconSm], eax
	invoke	LoadCursor,NULL,IDC_ARROW
	mov		D[wc.hCursor], eax

	invoke	RegisterClassEx, addr wc
	or eax,eax
	jnz >
		; If we were unable to register the class shut down
		invoke	ExitProcess, -1
	:

	invoke AtlAxWinInit

	invoke	CreateDialogParam, [hInstance],1000, NULL, NULL, NULL
	or eax,eax
	jnz >
		; If we were unable to create the dialog shut down
		invoke	ExitProcess, -1
	:
	mov [hDlg],eax

	invoke GetDlgItem,[hDlg],1001
	mov [hToolBar],eax

	call SetupToolbar

	invoke GetWindowRect,[hToolBar],offset rect
	mov eax,[rect.bottom]
	sub eax,[rect.top]
	push eax
	invoke GetClientRect,[hDlg],offset rect
	pop [rect.top]
	sub D[rect.bottom],30

	invoke CreateWindowEx,WS_EX_STATICEDGE,"AtlAxWin","about:none",WS_CHILD + WS_VISIBLE +WS_VSCROLL,[rect.left],[rect.top],[rect.right],[rect.bottom],[hDlg],1001,[hInstance],NULL
	mov [hAtl],eax

	invoke AtlAxGetControl, [hAtl],offset pIUnknown
	CoInvoke(pIUnknown,IWebBrowser2.IUnknown.QueryInterface,offset IID_IWebBrowser2,offset pIWebBrowser2)
	CoInvoke(pIWebBrowser2,IWebBrowser2.put_AddressBar,VARIANT_FALSE)
	CoInvoke(pIWebBrowser2,IWebBrowser2.put_MenuBar,VARIANT_FALSE)

	CoInvoke(pIWebBrowser2,IWebBrowser2.ClientToWindow,offset rect.right,offset rect.bottom)
	invoke SetWindowPos,[hAtl],NULL,[rect.left],[rect.top],[rect.right],[rect.bottom],SWP_NOMOVE + SWP_NOZORDER
	
	invoke AtlAdvise,[pIWebBrowser2],offset objEventSync,offset IID_DWebBrowserEvents2,offset dwCookie

	invoke GoToURL,[pIWebBrowser2],"http://www.masm32.com/board/index.php?board=8.0"

	invoke LoadIcon,[hInstance],1
	invoke SendMessage,[hDlg],WM_SETICON,ICON_SMALL,eax

	invoke ShowWindow,[hDlg],[nCmdShow]

	:
		invoke GetMessage, ADDR msg,NULL,0,0
		or eax,eax
		jz >
			invoke IsDialogMessage, [hDlg], ADDR msg
			or eax,eax
			jnz <
				invoke TranslateMessage, ADDR msg
				invoke DispatchMessage, ADDR msg
				jmp <
	:

	mov eax,[msg.wParam]

	ret
ENDF

DlgProc FRAME hwnd,uMsg,wParam,lParam
	LOCAL rect	:RECT

	cmp D[uMsg],WM_CREATE
	jne >.WM_COMMAND
		jmp >>.EXIT

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >>.WBN_NAVIGATECOMPLETE
		movzx eax,W[wParam]
		cmp eax,CMD_PREV
		jne >>
			invoke GoBack,[pIWebBrowser2]
			jmp >>.EXIT
		:
		cmp eax,CMD_NEXT
		jne >>
			invoke GoForward,[pIWebBrowser2]
			jmp >>.EXIT
		:
		cmp eax,CMD_REFRESH
		jne >>
			invoke Refresh,[pIWebBrowser2]
			jmp >>.EXIT
		:
		cmp eax,CMD_HOME
		jne >>
			invoke GoToURL,[pIWebBrowser2],"http://www.masm32.com/board/index.php?board=8.0"
			jmp >>.EXIT
		:
		cmp eax,CMD_STOP
		jne >>
			invoke Stop,[pIWebBrowser2]
			jmp >>.EXIT
		:
		jmp >>.EXIT

	.WBN_NAVIGATECOMPLETE
	cmp D[uMsg],WBN_NAVIGATECOMPLETE
	jne >>.WBN_DOWNLOADCOMPLETE
		invoke GetName,[pIWebBrowser2],offset url
		invoke SetWindowText,[hwnd],offset url
		ret

	.WBN_DOWNLOADCOMPLETE
	cmp D[uMsg],WBN_DOWNLOADCOMPLETE
	jne >>.WBN_QUIT
		invoke GetName,[pIWebBrowser2],offset url
		invoke SetWindowText,[hwnd],offset url
		ret

	.WBN_QUIT
	cmp D[uMsg],WBN_QUIT
	jne >>.WM_SIZE
		invoke AtlUnadvise,[pIWebBrowser2],offset IID_DWebBrowserEvents2,[dwCookie]
		CoInvoke(pIUnknown,IWebBrowser2.IUnknown.Release)
		CoInvoke(pIWebBrowser2,IWebBrowser2.IUnknown.Release)
		invoke PostQuitMessage,0
		jmp >>.DEFPROC

	.WM_SIZE
	cmp D[uMsg],WM_SIZE
	jne >>.WM_DESTROY
		cmp D[pIWebBrowser2], 0
		je >>.EXIT
		invoke GetWindowRect,[hToolBar],offset rect
		mov eax,[rect.bottom]
		sub eax,[rect.top]
		push eax
		invoke GetClientRect,[hDlg],offset rect
		pop [rect.top]
		sub D[rect.bottom],30
		CoInvoke(pIWebBrowser2,IWebBrowser2.ClientToWindow,offset rect.right,offset rect.bottom)
		invoke SetWindowPos,[hAtl],NULL,[rect.left],[rect.top],[rect.right],[rect.bottom],SWP_NOMOVE + SWP_NOZORDER
		jmp >>.EXIT

	.WM_DESTROY
	cmp D[uMsg],WM_DESTROY
	jne >.DEFPROC
		invoke AtlUnadvise,[pIWebBrowser2],offset IID_DWebBrowserEvents2,[dwCookie]
		CoInvoke(pIUnknown,IWebBrowser2.IUnknown.Release)
		CoInvoke(pIWebBrowser2,IWebBrowser2.IUnknown.Release)
		invoke PostQuitMessage,0

	.DEFPROC
		invoke DefWindowProc,[hwnd],[uMsg],[wParam],[lParam]
		ret

	.EXIT

	xor eax,eax
	ret

ENDF

SetupToolbar:
	invoke SendMessage,[hToolBar],TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,0
	invoke ImageList_LoadImage,[hInstance],IDR_TBBITMAP,16,16,0,IMAGE_BITMAP,LR_CREATEDIBSECTION
	mov [hImlSmall],eax
	invoke ImageList_SetBkColor,[hImlSmall],CLR_NONE
	invoke SendMessage,[hToolBar],TB_SETIMAGELIST,0,[hImlSmall]
	invoke SendMessage,[hToolBar],TB_SETINDENT,8,0
	invoke SendMessage,[hToolBar],TB_ADDBUTTONS,nToolbarBtns,OFFSET tbrbtns
	invoke SendMessage,[hToolBar],TB_AUTOSIZE,0,0
	RET

Stop FRAME pInterface
	
	CoInvoke(pInterface,IWebBrowser2.Stop)
	RET
ENDF

GoBack FRAME pInterface
	
	CoInvoke(pInterface,IWebBrowser2.GoBack)
	RET
ENDF

Refresh FRAME pInterface
	
	CoInvoke(pInterface,IWebBrowser2.Refresh)
	RET
ENDF

GoForward FRAME pInterface
	
	CoInvoke(pInterface,IWebBrowser2.GoForward)
	RET
ENDF

GoHome FRAME pInterface
	
	CoInvoke(pInterface,IWebBrowser2.GoHome)
	RET
ENDF

GetURL FRAME pInterface, pszURL
	LOCAL pbstrURL:D
	invoke SysAllocStringLen ,NULL,1024
	mov [pbstrURL],eax

	CoInvoke(pInterface,IWebBrowser2.get_LocationURL,[pbstrURL])

	// Convert the url to ANSI
	mov eax,[pbstrURL]
	mov eax,[eax]
	invoke WideCharToMultiByte,CP_ACP,NULL,eax,-1,[pszURL],1024,"",NULL
	push eax
	invoke SysFreeString,[pbstrURL]
	pop eax
	RET
ENDF

GetName FRAME pInterface, pszName
	LOCAL pbstrName:D
	invoke SysAllocStringLen ,NULL,1024
	mov [pbstrName],eax

	CoInvoke(pInterface,IWebBrowser2.get_LocationName,[pbstrName])

	// Convert the url to ANSI
	mov eax,[pbstrName]
	mov eax,[eax]
	invoke WideCharToMultiByte,CP_ACP,NULL,eax,-1,[pszName],1024,"",NULL
	push eax
	invoke SysFreeString,[pbstrName]
	pop eax
	RET
ENDF

GoToURL FRAME pInterface, pszURL
	LOCAL wszURL[1024]:W
	LOCAL pbstrURL:D
	LOCAL flags:VARIANT

	mov W[flags.vt], VT_I2
	mov W[flags.iVal], navNoHistory
	// Convert the url to unicode then create a BSTR with it
	invoke MultiByteToWideChar,CP_ACP,NULL,[pszURL],-1,offset wszURL,1024
	invoke SysAllocString,offset wszURL
	mov [pbstrURL],eax
	//_self
	CoInvoke(pInterface,IWebBrowser2.Navigate,[pbstrURL],offset flags,L"_self",NULL,NULL)
	push eax
	invoke SysFreeString,[pbstrURL]
	pop eax
	RET
ENDF

// Event Sync

// IUnknown Implementation

DWebBrowserEvents2_QueryInterface FRAME  this, riid, ppv

	mov eax,[ppv]
	mov D[eax], 0

	invoke IsEqualGUID, [riid], offset IID_DWebBrowserEvents2
	test eax,eax
	jnz >>.SUPPORTED

	invoke IsEqualGUID, [riid], offset IID_IUnknown
	test eax,eax
	jnz >>.SUPPORTED

	invoke IsEqualGUID, [riid], offset IID_IDispatch
	test eax,eax
	jnz >>.SUPPORTED

	mov eax,E_NOINTERFACE
	ret

	.SUPPORTED
	mov eax, [this]
	mov edx, [ppv]
	mov [edx],eax
	mov eax, NOERROR
	RET
ENDF

DWebBrowserEvents2_AddRef FRAME this
	mov eax,[this]
	inc D[eax+COMObject.nRefCount]
	mov eax,[eax+COMObject.nRefCount]
	mov eax,1
	ret
ENDF

DWebBrowserEvents2_Release FRAME this
	mov eax,[this]
	dec D[eax+COMObject.nRefCount]
	js >.SIGNED
	jnz >
		.SIGNED
		mov D[eax+COMObject.nRefCount],0
		xor eax,eax
		ret
	:
	mov eax,[eax+COMObject.nRefCount]

	ret
ENDF

// IDispatch Implementation

IDispatch_Default FRAME this
	
	mov eax,E_NOTIMPL
	
	RET
ENDF

DWebBrowserEvents2_GetIDsOfNames FRAME this, riid, rgszNames,  cNames,  lcid, rgDispId
	invoke DispGetIDsOfNames,[this], [rgszNames], [cNames], [rgDispId]
	ret
ENDF

DWebBrowserEvents2_Invoke FRAME this, dispIdMember, riid, lcid, wFlags, pdispparams, pVarResult, pExcepInfo, puArgErr

	mov eax,[dispIdMember]
	cmp eax,DISPID_DOWNLOADCOMPLETE
	jne >
		invoke SendMessage, [hDlg],WBN_DOWNLOADCOMPLETE,0,[pdispparams]
	:
	cmp eax,DISPID_NAVIGATECOMPLETE
	jne >
		invoke SendMessage, [hDlg],WBN_NAVIGATECOMPLETE,0,[pdispparams]
	:
	cmp eax,DISPID_QUIT
	jne >
		invoke SendMessage, [hDlg],WBN_QUIT,0,[pdispparams]
	:
	
	mov eax,S_OK
	ret
ENDF

DWebBrowserEvents2_GetTypeInfo FRAME this, iTInfo, lcid, ppTInfo
	mov eax,E_NOTIMPL
	ret
ENDF

DWebBrowserEvents2_GetTypeInfoCount FRAME this, pctinfo
	mov eax,E_NOTIMPL
	ret
ENDF
